#! /usr/bin/env python
# -*- coding: utf-8 -*-
# TIME OF CREATION Wed Mar 24 12:22:46 2010
# ВРЕМЯ СОЗДАНИЯ Wed Mar 24 12:22:46 2010


import config

_input = config.input


##############################################################################################################
###
### Коалиционные игры 1x3
###
##############################################################################################################

#######################################################
###
### I против II, III, IV
###

def maxmin_game_table_I_a_II_III_IV():	
	'''
		Ищет максимин для I против II, III, IV
	'''
	first = []
	second = []
	for i2  in (1, 2):
		for i3  in (1, 2):
			for i4  in (1, 2):
				first.append( _input["1%s%s%s"%(i2, i3, i4)][0]  )
	min_1 = min(first)
	for i2  in (1, 2):
		for i3  in (1, 2):
			for i4  in (1, 2):
				second.append( _input["2%s%s%s"%(i2, i3, i4)][0] )
	min_2 = min(second)
	return max(min_1, min_2);
	

def game_table_I_a_II_III_IV():	
	'''
		Возвращает таблицу для I против II, III, IV
	'''
	
	table = []
	for i1  in (1, 2):
		row = []
		for i2  in (1, 2):
			for i3  in (1, 2):
				for i4  in (1, 2):
					row.append( _input["%s%s%s%s"%(i1, i2, i3, i4)][0]  )
		table.append(row)
	return table;

	
def str_game_table_I_a_II_III_IV():	
	res = r"\alpha_1 "
	for i2  in (1, 2):
		for i3  in (1, 2):
			for i4  in (1, 2):
				res += "& %s"%_input["1%s%s%s"%(i2, i3, i4)][0] 
	res += r"\\" + "\n"
	res += r"\alpha_2 "
	for i2  in (1, 2):
		for i3  in (1, 2):
			for i4  in (1, 2):
				res += "& %s"%_input["2%s%s%s"%(i2, i3, i4)][0] 
	res += r"\\" + "\n"
	return res;
			

#######################################################
###
### II против I, III, IV
###

def maxmin_game_table_II_a_I_III_IV():	
	'''
		Ищет максимин для II против I, III, IV
	'''
	first = []
	second = []
	for i1  in (1, 2):
		for i3  in (1, 2):
			for i4  in (1, 2):
				first.append( _input["%s1%s%s"%(i1, i3, i4)][1]  )
	min_1 = min(first)
	for i1  in (1, 2):
		for i3  in (1, 2):
			for i4  in (1, 2):
				second.append( _input["%s2%s%s"%(i1, i3, i4)][1] )
	min_2 = min(second)
	return max(min_1, min_2);
	
def game_table_II_a_I_III_IV():	
	'''
		Возвращает таблицу для II против I, III, IV
	'''
	
	table = []
	for i2  in (1, 2):
		row = []
		for i1  in (1, 2):
			for i3  in (1, 2):
				for i4  in (1, 2):
					row.append( _input["%s%s%s%s"%(i1, i2, i3, i4)][1]  )
		table.append(row)
	return table
	
def str_game_table_II_a_I_III_IV():	
	res = r"\beta_1 "
	for i1  in (1, 2):
		for i3  in (1, 2):
			for i4  in (1, 2):
				res += "& %s"%_input["%s1%s%s"%(i1, i3, i4)][1]
	res += r"\\" + "\n"
	res += r"\beta_1 "
	for i1  in (1, 2):
		for i3  in (1, 2):
			for i4  in (1, 2):
				res += "& %s"%_input["%s2%s%s"%(i1, i3, i4)][1]
	res += r"\\" + "\n"
	return res;


#######################################################
###
### III против I, II, IV
###


def maxmin_game_table_III_a_I_II_IV():	
	'''
		Ищет максимин для III против I, II, IV
	'''
	first = []
	second = []
	for i1  in (1, 2):
		for i2  in (1, 2):
			for i4  in (1, 2):
				first.append( _input["%s%s1%s"%(i1, i2, i4)][2] )
	min_1 = min(first)
	for i1  in (1, 2):
		for i2  in (1, 2):
			for i4  in (1, 2):
				second.append( _input["%s%s2%s"%(i1, i2, i4)][2] )
	min_2 = min(second)
	return max(min_1, min_2);
	
def game_table_III_a_I_II_IV():	
	'''
		Возвращает таблицу для III против I, II, IV
	'''
	
	table = []
	for i3  in (1, 2):
		row = []
		for i1  in (1, 2):
			for i2  in (1, 2):
				for i4  in (1, 2):
					row.append( _input["%s%s%s%s"%(i1, i2, i3, i4)][2]  )
		table.append(row)
	return table

def str_game_table_III_a_I_II_IV():	
	res = r"\gamma_1 "
	for i1  in (1, 2):
		for i2  in (1, 2):
			for i4  in (1, 2):
				res += "& %s"%_input["%s%s1%s"%(i1, i2, i4)][2]
	res += r"\\" + "\n"
	res += r"\gamma_2 "
	for i1  in (1, 2):
		for i2  in (1, 2):
			for i4  in (1, 2):
				res += "& %s"%_input["%s%s2%s"%(i1, i2, i4)][2]
	res += r"\\" + "\n"
	return res;


#######################################################
###
### IV против I, II, III
###

def maxmin_game_table_IV_a_I_II_III():	
	'''
		Ищет максимин для IV против I, II, III
	'''
	first = []
	second = []
	for i1  in (1, 2):
		for i2  in (1, 2):
			for i3  in (1, 2):
				first.append( _input["%s%s%s1"%(i1, i2, i3)][3] )
	min_1 = min(first)
	for i1  in (1, 2):
		for i2  in (1, 2):
			for i3  in (1, 2):
				second.append( _input["%s%s%s2"%(i1, i2, i3)][3] )
	min_2 = min(second)
	return max(min_1, min_2);
	
def game_table_IV_a_I_II_III():	
	'''
		Возвращает таблицу для IV против I, II, III
	'''
	
	table = []
	for i4  in (1, 2):
		row = []
		for i1  in (1, 2):
			for i2  in (1, 2):
				for i3  in (1, 2):
					row.append( _input["%s%s%s%s"%(i1, i2, i3, i4)][3]  )
		table.append(row)
	return table
	
def str_game_table_IV_a_I_II_III():	
	res = r"\delta_1 "
	for i1  in (1, 2):
		for i2  in (1, 2):
			for i3  in (1, 2):
				res += "& %s"%_input["%s%s%s1"%(i1, i2, i3)][3]
	res += r"\\" + "\n"
	res += r"\delta_2 "
	for i1  in (1, 2):
		for i2  in (1, 2):
			for i3  in (1, 2):
				res += "& %s"%_input["%s%s%s2"%(i1, i2, i3)][3]
	res += r"\\" + "\n"
	return res;

##############################################################################################################
###
### Коалиционные игры 2x2
###
##############################################################################################################

#######################################################
###
### I, II против III, IV
###

def maxmin_game_table_I_II_a_III_IV():
	_min = []
	for i1  in (1, 2):
		for i2  in (1, 2):
			row = []
			for i3  in (1, 2):
				for i4  in (1, 2):
					sum_1 = _input["%s%s%s%s"%(i1, i2, i3, i4)][0]
					sum_2 = _input["%s%s%s%s"%(i1, i2, i3, i4)][1]
					row.append(sum_1 + sum_2) 
			_min.append( min(row) )
	return max(_min)	


def str_game_table_I_II_a_III_IV():
	res = ""
	for i1  in (1, 2):
		for i2  in (1, 2):
			res += r"\alpha_%s, \beta_%s" %(i1, i2)
			for i3  in (1, 2):
				for i4  in (1, 2):
					sum_1 = _input["%s%s%s%s"%(i1, i2, i3, i4)][0]
					sum_2 = _input["%s%s%s%s"%(i1, i2, i3, i4)][1]
					res +=  " & %s " %(sum_1 + sum_2)
			res += r"\\" + "\n"
	return res;
	
		
#######################################################
###
### I, III против II, IV
###

def maxmin_game_table_I_III_a_II_IV():
	_min = []
	for i1  in (1, 2):
		for i3  in (1, 2):
			row = []
			for i2  in (1, 2):
				for i4  in (1, 2):
					sum_1 = _input["%s%s%s%s"%(i1, i2, i3, i4)][1-1]
					sum_2 = _input["%s%s%s%s"%(i1, i2, i3, i4)][3-1]
					row.append(sum_1 + sum_2) 
			_min.append( min(row) )
	return max(_min)	
	
def str_game_table_I_III_a_II_IV():
	res = ""
	for i1  in (1, 2):
		for i3  in (1, 2):
			res +=  r"\alpha_%s, \gamma_%s" %(i1, i3)
			for i2  in (1, 2):
				for i4  in (1, 2):
					sum_1 = _input["%s%s%s%s"%(i1, i2, i3, i4)][1-1]
					sum_2 = _input["%s%s%s%s"%(i1, i2, i3, i4)][3-1]
					res +=  " & %s " %(sum_1 + sum_2)
			res += r"\\" + "\n"
	return res;

	
#######################################################
###
### I, IV против II, III
###

def maxmin_game_table_I_IV_a_II_III():
	_min = []
	for i1  in (1, 2):
		for i4  in (1, 2):
			row = []
			for i2  in (1, 2):
				for i3  in (1, 2):
					sum_1 = _input["%s%s%s%s"%(i1, i2, i3, i4)][1-1]
					sum_2 = _input["%s%s%s%s"%(i1, i2, i3, i4)][4-1]
					row.append(sum_1 + sum_2) 
			_min.append( min(row) )
	return max(_min)	
	
def str_game_table_I_IV_a_II_III():
	res = ""
	for i1  in (1, 2):
		for i4  in (1, 2):
			res += r"\alpha_%s, \delta_%s" %(i1, i4)
			for i2  in (1, 2):
				for i3  in (1, 2):
					sum_1 = _input["%s%s%s%s"%(i1, i2, i3, i4)][1-1]
					sum_2 = _input["%s%s%s%s"%(i1, i2, i3, i4)][4-1]
					res +=  " & %s " %(sum_1 + sum_2)
			res += r"\\" + "\n"
	return res;
		
		
def print_game_table_2x2():
	print "I, II -> III, IV"
	print str_game_table_I_II_a_III_IV()
	print "I, III -> II, IV"
	print str_game_table_I_III_a_II_IV()
	print "I, IV -> II, III"
	print str_game_table_I_IV_a_II_III()		

def print_maxmin_game_table_all():

	print ' I -> ', maxmin_game_table_I_a_II_III_IV()		
	print 'II -> ', maxmin_game_table_II_a_I_III_IV()
	print 'III-> ',maxmin_game_table_III_a_I_II_IV();
	print 'IV-> ',maxmin_game_table_IV_a_I_II_III();
	print
	print 'I & II -> ', maxmin_game_table_I_II_a_III_IV();
	print 'I & III -> ', maxmin_game_table_I_III_a_II_IV();
	print 'I & IV-> ', maxmin_game_table_I_IV_a_II_III();

print game_table_IV_a_I_II_III();